/*
**
**                           Main.c
**
**
**********************************************************************/
/*
   Last committed:     $Revision: 00 $
   Last changed by:    $Author: $
   Last changed date:  $Date:  $
   ID:                 $Id:  $

**********************************************************************/
#include "stm32f10x_conf.h"

#include "FreeRTOS.h"
#include "task.h"
//#include "timers.h"
//#include "queue.h"
//#include "semphr.h"
//#include "event_groups.h"

TaskHandle_t Task_1_Handle;
TaskHandle_t Task_2_Handle;
TaskHandle_t Task_3_Handle;
TaskHandle_t Task_4_Handle;

extern uint32_t SystemCoreClock;
volatile uint32_t Start_SleepTime=0;
volatile float CPU_Load;

void Task_1(void const *argument) //  1.
{
  while(1)
  {
    GPIO_SetBits(GPIOA, GPIO_Pin_4);
    vTaskDelay(200);
    GPIO_ResetBits(GPIOA, GPIO_Pin_4);
    vTaskDelay(100);
  }
}

void Task_2(void const *argument) //  2.
{
  while(1)
  {
    GPIO_SetBits(GPIOA, GPIO_Pin_5);
    vTaskDelay(50);
    GPIO_ResetBits(GPIOA, GPIO_Pin_5);
    vTaskDelay(400);
  }
}

void Task_3(void const *argument) //  3.
{
  while(1)
  {
    GPIO_SetBits(GPIOA, GPIO_Pin_6);
    vTaskDelay(100);
    GPIO_ResetBits(GPIOA, GPIO_Pin_6);
    vTaskDelay(500);
  }
}


void Task_4(void const *argument) //  4.
{
  while(1)
  {

      static volatile uint32_t i;
      for (i=0; i<1000; i++);
      vTaskDelay(1);

//    GPIO_SetBits(GPIOA, GPIO_Pin_7);
//    vTaskDelay(200);
//    GPIO_ResetBits(GPIOA, GPIO_Pin_7);
//    vTaskDelay(200);
  }
}


void vApplicationIdleHook(void) //      , . .   .
{
    if (Start_SleepTime == 0)
        Start_SleepTime = DWT->CYCCNT;  //     .

    __WFI();  //      .
}


void vApplicationTickHook(void) //      .
{
    static uint32_t Count, SleepTime;

    if (Start_SleepTime)
    {
        SleepTime += DWT->CYCCNT - Start_SleepTime;
        Start_SleepTime = 0;
    }

    if (++Count >= configTICK_RATE_HZ) //  .
    {
        Count = 0;

        if (SleepTime != 0)
        {
            CPU_Load = 100 - 100.0f / (SystemCoreClock / (float)SleepTime); //  CPU  .
        }
        else CPU_Load = 100;

        SleepTime = 0;
    }
}

int main(void)
{

    CoreDebug->DEMCR |= CoreDebug_DEMCR_TRCENA_Msk; //  TRACE
    DWT->CTRL |= DWT_CTRL_CYCCNTENA_Msk;            //  DWT 


    {
        GPIO_InitTypeDef GPIO_InitStructure; //   A4, A5, A6  A7  

        RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);

        GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
        GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;

        GPIO_Init(GPIOA, &GPIO_InitStructure);
    }

    //  .

    xTaskCreate((TaskFunction_t) Task_1, "Blinker 1",
                configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, Task_1_Handle);

    xTaskCreate((TaskFunction_t) Task_2, "Blinker 2",
                configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, Task_2_Handle);

    xTaskCreate((TaskFunction_t) Task_3, "Blinker 3",
                configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, Task_3_Handle);

    xTaskCreate((TaskFunction_t) Task_4, "Blinker 4",
                configMINIMAL_STACK_SIZE, NULL, tskIDLE_PRIORITY + 1, Task_4_Handle);


    //   .
    vTaskStartScheduler();

    while(1)
    {
    }
}
